#include "stdafx.h"
#include <string.h>	// strncpy()
//#include "BSch.h"
//#include "NUT.h"	//̒ resource.h CN[hĂ
#include "ce2type.h"
#include "ce2data.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static const int ObjectSizeTable[]={
	sizeof(CCe2Junction),	// 0 - JUNCTIONDATA
	sizeof(CCe2Junction),	// 1 - ENTRYDATA
	sizeof(CCe2Wire),		// 2 - BUSDATA
	sizeof(CCe2Wire),		// 3 - WIREDATA
	sizeof(CCe2Wire),		// 4 - DLINEDATA
	sizeof(CCe2Label),		// 5 - LABELDATA
	sizeof(CCe2Label),		// 6 - TAGDATA
	sizeof(CCe2Comment),	// 7 - COMMENTDATA
	sizeof(CCe2Part),		// 8 - PARTDATA
	sizeof(CCe2FileHeader)	// 9 - FILEHEADER
};


////////////////////////////////////////////////////////////
//@ f[^̃TCYԂ
static int GetDataSize(CCe2Type* pData)
{
	if(pData->stus<=9) return ObjectSizeTable[pData->stus];
	else  if(pData->stus>=16) return pData->dsize;
	else  return 0;
}


////////////////////////////////////////////////////////////
//			b|pXJ
void g_cstr2pstr(char *cstr,char *pstr)
{
	int i;
	char *topptr;
	
	topptr=pstr;
	
	pstr++;i=0;
	while(*cstr){
		*pstr++ = *cstr++;
		i++;
	}
	*topptr=i;
}



////////////////////////////////////////////////////////////
//			pXJ|b
void g_pstr2cstr(char *pstr,char *cstr)
{
	int i,n;
	
	n=*pstr++;
	for(i=0;i<n;i++) *cstr++ = *pstr++;
	*cstr=0;
}


////////////////////////////////////////////////////////////
//	㕔̐l̏
//  Ƃ̐lԂ
int g_remove_tail_num(char *str)
{
	int i=0;
	
	if(!*str) return 0;
	while(*str){
		str++;i++;
	}
	while(isdigit(*(str-1)) && (i-1)){
		str--;
		i--;
	}
	i=atoi(str);
	*str=0;
	return i;
}

////////////////////////////////////////////////////////////
//		pXJr
int g_strcmp_PAS(char *str0,char *str1)
{
	int i,j;
	
	
	j=(*str0)-(*str1);
	if(j) return j;
	i=*str0;
	while(i){
		str0++;str1++;
		j=(*str0)-(*str1);
		if(j) return j;
		i--;
	}
	return 0;
}


////////////////////////////////////////////////////////////
//@ f[^t@C̓ǂݍ
BOOL CCe2Data::ReadFile(LPCSTR pszFileName)
{
	delete[]m_pBuff;
	m_pBuff=NULL;
	m_listPart.RemoveAll();
//	delete[]m_pPartData;
//	m_pBuff=NULL;
//	m_nPartCount=0;

	DWORD dwScanOffset;
	int   nDataSize;
	BYTE* pData;
//	CPtrList listPart;
	CCe2FileHeader* pHeader;
	static const char DataFile_ID_1[]="CE DATA FILE $0000\x1a";
	static const char DataFile_ID_2[]="CE DATA FILE $0001\x1a";


	{	// CFile file  XR[v
		CFile file;
		if(file.Open(pszFileName,CFile::modeRead|CFile::shareExclusive)==FALSE){
			return FALSE;	//t@CI[vs
		}
		m_dwBuffSize=file.GetLength();
		m_pBuff=new BYTE[m_dwBuffSize];
		if(!m_pBuff) return FALSE;
		//f[^̈Cǂ
		if(m_dwBuffSize!=file.Read(m_pBuff,m_dwBuffSize)) goto ERREND;
		file.Close();
	}
	pHeader=(CCe2FileHeader*)m_pBuff;

	if(    lstrcmp(pHeader->id,DataFile_ID_1) 
		&& lstrcmp(pHeader->id,DataFile_ID_2) ) goto ERREND;

	//f[^XLāA񃊃Xgɓ
	dwScanOffset=0;
	pData=m_pBuff;
	while(dwScanOffset<m_dwBuffSize){
		if( ((CCe2Type*)pData)->stus == PARTDATA){
			m_listPart.AddTail((void*)pData);
		}
		nDataSize=GetDataSize((CCe2Type*)pData);
		if(nDataSize==0) goto ERREND;
		dwScanOffset+=nDataSize;
		pData+=nDataSize;
	}
/*
	//XgzɈڂ
	m_nPartCount=listPart.GetCount();
	if(m_nPartCount){
		int i=0;
		m_pPartData=(CCe2Part**) new BYTE[sizeof(CCe2Part*)*m_nPartCount];
		POSITION pos=listPart.GetHeadPosition();
		while(i<m_nPartCount && pos){
			m_pPartData[i]=(CCe2Part*)listPart.GetNext(pos);
		}
	}
	listPart.RemoveAll();
*/
	return TRUE;
ERREND:
	delete[]m_pBuff;
	m_pBuff=NULL;
//	delete[]m_pPartData;
//	m_nPartCount=0;
	return FALSE;
}


////////////////////////////////////////////////////////////
//@ f[^t@C̏
BOOL CCe2Data::WriteFile(LPCSTR pszFileName)
{
	if(!m_pBuff) return FALSE;

	CFile file;
	BOOL bResult=TRUE;
	if(file.Open(	pszFileName,
					CFile::modeCreate|CFile::modeWrite|CFile::shareExclusive
				)==FALSE){
		return FALSE;	//t@CI[vs
	}
	try{
		file.Write(m_pBuff,m_dwBuffSize);
	}
	catch(CFileException *e){
		if(e->m_cause!=CFileException::none) bResult=FALSE;
		e->Delete();
	}
	return bResult;
}


